/*
 * BEGIN_HEADER - DO NOT EDIT
 * 
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the "License").  You may not use this file except
 * in compliance with the License.
 *
 * You can obtain a copy of the license at
 * https://open-jbi-components.dev.java.net/public/CDDLv1.0.html.
 * See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL
 * HEADER in each file and include the License file at
 * https://open-jbi-components.dev.java.net/public/CDDLv1.0.html.
 * If applicable add the following below this CDDL HEADER,
 * with the fields enclosed by brackets "[]" replaced with
 * your own identifying information: Portions Copyright
 * [year] [name of copyright owner]
 */

/*
 * @(#)Operation.java
 *
 * Copyright 2004-2007 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * END_HEADER - DO NOT EDIT
 */
package org.glassfish.openesb.pojose.api.annotation;

import java.lang.annotation.*;
/**
 * Annotation designates a method to be called for all incoming Endpoint request 
 * messages.
 * Methods should have one parmeter of type String, Node, byte[], Source, 
 * NormalizedMessage and MessageExchange.
 * 
 * For 
 * Specify output messages WSDL MessageTypeNS and MessageType for return type of 
 * String, Node and Source if consuming JBI component expects WSDL11 wrapper message 
 * ("<jbi:message>" to contain these attributes.
 * 
 * Return type is either from method annotated with &amp;#064;Operation or 
 * &amp;#064;OnDone if &amp;#064;Operation annotated method has "void" return type.
 * 
 * @author gmpatil
 * @author sgenipudi
 * 
 */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface Operation {
    public String name() default "";
    /**
     * @deprecated 11/06/08, use outMessageTypeQN.
     */
    public String outMessageTypeNS() default "";
    
    /**
     * @deprecated 11/06/08, use outMessageTypeQN.
     * @return
     */    
    public String outMessageType() default "";
    public String outMessageTypeQN() default "";    
}